/*
	$Id: CppMessagePortConnection.h,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <exception>
#include <Carbon/Carbon.h>
#include "CppCFString.h"
#include "CppCFData.h"

/*
	CFMessagePortRefgAT[o[ւ̃RlNV𒣂NXłB
	̃NX̃Rs[RXgN^yoperator=́ARs[CFMessagePortRefCFRetain܂B
*/

class CppMessagePortConnection
{
	protected:
		CFMessagePortRef portRef;
	
	public:
		// |[g쐬Ɏsexception𓊂B
		CppMessagePortConnection(); // ȃCX^X쐬B
		CppMessagePortConnection(const CppCFString& port_name) throw(std::exception);
		CppMessagePortConnection(const CppMessagePortConnection& copy_src);
		virtual ~CppMessagePortConnection();
		
		// 肪ԂȂCppCFDataԂB
		// MɎsexception𓊂B
		virtual CppCFData send(SInt32 message_id) throw(std::exception);
		virtual CppCFData send(SInt32 message_id,const CppCFData& attachment) throw(std::exception);
		
		virtual CppMessagePortConnection& operator=(CppMessagePortConnection& copy_src);
};