/*
	$Id: UserDicSaver.h,v 1.4 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@interface UserDicSaver : NSObject
{
	int interval_minutes;
	bool is_running;
	bool is_saving_now;
	bool is_dirty;
	
	bool flag_terminate_saving; // ̃tOsaverThread͂ɒ~AtONAB
}
// public
+ (UserDicSaver*)sharedSaver;
- (void)start; // UserDicSaverJnBɊJnĂ牽ȂB
- (void)saveNow; // dirtyȏꍇɋIɕۑJnBɃXbhĂ~߂B
- (void)waitUntilSaverFinishes; // Z[o[XbhI܂ő҂B
- (void)userDicGotDirty; // [U[ύXꂽɌĂԁB

// private
- init;
- (void)dealloc;
- (void)triggerThread:(NSNull*)null_value;
- (void)saverThread:(NSNull*)null_value;
- (void)terminateSaving;
@end
