/*
	$Id: BIM.r,v 1.5 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define UseExtendedThingResource 1

#include <Carbon/Carbon.r>
#include "BIMScript.h"

resource 'thng' (128)
{
    'tsvc', // R|[lg^CvBTextServiceȂ̂'tsvc'
    'inpm',	// R|[lgTu^CvBInputMethodȂ̂'inpm'
    'ccm ',	// j[Nȃx_[R[hB
    0x8000 + kBIMScript * 0x100 + kBIMLanguage, // ݒ
    kAnyComponentFlagsMask, // kAnyComponentFlagsMaskłȂ΂ȂȂB
    'dlle', kBaseResourceID, // Gg|Cg̖
    'STR ', kBaseResourceID, // IM̖
    'STR ', kBaseResourceID, // IḾ̖iǂ炪ǂ̂悤Ɏg邩͒mȂj
    'ICON', kBaseResourceID,
    0x00010000,
    componentHasMultiplePlatforms,
    15872 + kBIMScript * 0x200,
    {
        0x8000 + kBIMScript * 0x100 + kBIMLanguage, // ݒ
        'dlle', kBaseResourceID, 1000
    }
};

resource 'dlle' (kBaseResourceID) {
	"BIMComponentDispatch"
};

resource 'MENU' (kBaseResourceID + 1)
{
    kBaseResourceID,
    textMenuProc,
    allEnabled,
    enabled,
    "00000",
    {
        "Show Keyboard Palette", noIcon, "K", noMark, plain,
        "Show Send Event Palette", noIcon, "D", noMark, plain,
        "-", noIcon, noKey, noMark, plain,
        "Convert To Lowercase", noIcon, "L", noMark, plain,
        "Convert To Uppercase", noIcon, "U", noMark, plain
    }
};

resource 'xmnu' (kBaseResourceID + 1)
{
    versionZero
    {
        {
            dataItem {'SHKP', kMenuShiftModifier + kMenuControlModifier + kMenuNoCommandModifier,
                      currScript, 0, 0, noHierID, sysFont, naturalGlyph},
            dataItem {'SHDP', kMenuShiftModifier + kMenuControlModifier + kMenuNoCommandModifier,
                      currScript, 0, 0, noHierID, sysFont, naturalGlyph},
            skipItem {},
            dataItem {'CLOW', kMenuShiftModifier + kMenuControlModifier + kMenuNoCommandModifier,
                      currScript, 0, 0, noHierID, sysFont, naturalGlyph},
            dataItem {'CUPP', kMenuShiftModifier + kMenuControlModifier + kMenuNoCommandModifier,
                      currScript, 0, 0, noHierID, sysFont, naturalGlyph}
        }
    }
};

resource 'STR ' (kBaseResourceID)
{
    "AquaSKK"
};

resource 'STR#' (kBaseResourceID + 1)
{
    {
	"Show Keyboard Palette",
        "Hide Keyboard Palette",
	"Show Send Event Palette",
        "Hide Send Event Palette"
    }
};
