/*
	$Id: ClientConnectionFactory.h,v 1.2 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include "CppMessagePortConnection.h"
#include "CppCFString.h"

/*
	NCAgւ̐ڑ𐶐SingletonłB
	ftHgŌ݃ANeBuȃNCAgւ̐ڑ𐶐܂A
	ANeBuȃNCAgςxɍĐݒ肵Ȃ΂Ȃ܂B
*/

class ClientConnectionFactory
{
	protected:
		ProcessSerialNumber default_target;
		
		ClientConnectionFactory();
		virtual ~ClientConnectionFactory();
		
		static CppCFString generateClientPortName(const ProcessSerialNumber& psn_of_target);
		
	public:
		static ClientConnectionFactory& sharedFactory();
		
		virtual ClientConnectionFactory& setDefaultTarget(const ProcessSerialNumber& psn_of_target);
		
		virtual CppMessagePortConnection newConnection() const; // ANeBuȃNCAgւ̐ڑ
		virtual CppMessagePortConnection newConnection(const ProcessSerialNumber& psn_of_target) const; // ڑPSNŎw
};