/*
	$Id: ClientMessageReceiver.cpp,v 1.2 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <Carbon/Carbon.h>
#include "ClientMessageReceiver.h"
#include "BIMClientServer.h"
#include "ClientConfiguration.h"

static ClientMessageReceiver* _shared_instance = NULL;

void ClientMessageReceiver::start()
{
	if (_shared_instance == NULL)
	{
		_shared_instance = new ClientMessageReceiver();
	}
}

ClientMessageReceiver::ClientMessageReceiver() throw(std::exception)
	:CppMessagePortServer(generatePortName(),CFRunLoopGetCurrent())
{
	
}

ClientMessageReceiver::~ClientMessageReceiver()
{

}

CppCFString ClientMessageReceiver::generatePortName()
{
	// vZXVAio[|[g쐬BAvԂŏdȂׂłB
	ProcessSerialNumber processSerialNumber;
    GetCurrentProcess(&processSerialNumber);
	
	CFMutableStringRef portName;
    CFStringRef processSerialNumberStringRef;
    Str255 processSerialNumberString;
    Str255 processSerialNumberLowString;
	
    NumToString( processSerialNumber.highLongOfPSN, processSerialNumberString );
    NumToString( processSerialNumber.lowLongOfPSN, processSerialNumberLowString );
    BlockMoveData( processSerialNumberLowString + 1,
                   processSerialNumberString + processSerialNumberString [0] + 1,
                   processSerialNumberLowString [0] );
    processSerialNumberString [0] += processSerialNumberLowString [0];
	
    portName = CFStringCreateMutableCopy( NULL, 255, CFSTR( kBasicServerPortName ) );
    processSerialNumberStringRef = CFStringCreateWithPascalString( NULL,
                                                                   processSerialNumberString,
                                                                   CFStringGetSystemEncoding() );
    CFStringAppend( portName, processSerialNumberStringRef );
    CFRelease( processSerialNumberStringRef );
    return CppCFString(portName);
}

CppCFData ClientMessageReceiver::messageReceived(SInt32 message_id,const CppCFData& attachment)
{
	switch (message_id)
	{
        case kBasicMessageIsSkkEggLikeNewline:
			// ͖ʂBʂAR[hIɂ͂̕Y킾B
			ClientConfiguration::sharedConfiguration().reloadConfiguration();
			break;
			
        default:
            break;
    }
	return CppCFData();
}